﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.IO;
using System.Drawing;
using System.Windows.Forms;
using MikuMikuPlugin;
using DxMath;

using Microsoft.DirectX;
using Microsoft.DirectX.DirectInput;

namespace UgoBone
{
    public class Class1:IResidentPlugin,ICanSavePlugin,IHaveUserControl
    {
        private MyUserControl myUserControl;
        private Hashtable loadSaveParam = new Hashtable();

        private bool[] bs_;
        private DxMath.Vector4 stick_;
        private DxMath.Quaternion rv_;
        private DxMath.Quaternion tv_;
        private DxMath.Quaternion fv_;
        private int curPov_ = -1;
        private int prePov_ = -1;

        private MotionData cur;

        private float RotRate = 0.08f;
        private int maxSpeedParam_ = 1;
        private double SpeedRate_ = 2;

        private float velocity_ = 0;

        private clsDirectInput di;

        private float PadCenter = 32768.0f;

        public Guid GUID
        {
            get { return new Guid("F1618253-1871-48D8-8975-91D016F822FA"); }
        }

        public IWin32Window ApplicationForm { get; set; }

        public Scene Scene { get; set; }

        public string Description
        {
            get { return "UgoBone Plugin v0.03 by Usagi"; }
        }

        public Image Image
        {
            get { return Properties.Resources.image; }
        }

        public Image SmallImage
        {
            get { return Properties.Resources.smallimage; }
        }

        public string Text
        {
            get { return "ボーン" + System.Environment.NewLine + "操作"; }
        }

        public string EnglishText
        {
            get { return "Control" + System.Environment.NewLine + "Bone"; }
        }

        public UserControl CreateControl()
        {
            this.myUserControl = new MyUserControl();
            return this.myUserControl;
        }

        public void Initialize()
        {
        }

        public void Enabled()
        {

            di = new clsDirectInput();
            myUserControl.PadName = di.PadName;

            cur.Move = new DxMath.Vector3(0, 0, 0);
            cur.Rotation = DxMath.Quaternion.RotationAxis(DxMath.Vector3.UnitY, 0);
        }


        /** がんばらない飛行機 */
        private void typeA()
        {

            if (curPov_ >= 0 && prePov_ < 0)
            {
// 上下で最大速度の変更
                switch (curPov_)
                {
                    case 0:
                        maxSpeedParam_ += 1;
                        break;
                    case 18000:
                        maxSpeedParam_ -= 1;
                        if (maxSpeedParam_ < -1)
                        {
                            maxSpeedParam_ = -1;
                        }
                        break;
                }
            }
            if (maxSpeedParam_ >= 0)
            {
                SpeedRate_ = Math.Pow(2, maxSpeedParam_);
            }
            else
            {
                SpeedRate_ = 0;
            }


            //スティック
            float jx = stick_.X * Math.Abs(stick_.X);
            float jy = stick_.Y * Math.Abs(stick_.Y);
            float jz = stick_.Z * Math.Abs(stick_.Z);
            float jrz = stick_.W * Math.Abs(stick_.W);

            double ang = -jy * RotRate;
            DxMath.Vector3 n = rv_.Axis; // pitch
            n.Normalize();
            DxMath.Quaternion jrot = DxMath.Quaternion.RotationAxis(n, (float)ang);
            cur.Rotation = jrot * cur.Rotation;

            if (bs_[5 - 1])
            {
                ang = -jx * RotRate;
                n = fv_.Axis; // roll
                n.Normalize();
                jrot = DxMath.Quaternion.RotationAxis(n, (float)ang);
                cur.Rotation = jrot * cur.Rotation;

                ang = jrz * RotRate;
                n = tv_.Axis; // yaw
                n.Normalize();
                jrot = DxMath.Quaternion.RotationAxis(n, (float)ang);
                cur.Rotation = jrot * cur.Rotation;
            }
            else
            {
                ang = jx * RotRate;
                n = tv_.Axis; // yaw
                n.Normalize();
                jrot = DxMath.Quaternion.RotationAxis(n, (float)ang);
                cur.Rotation = jrot * cur.Rotation;
            }

            if (bs_[6 - 1])
            {
                velocity_ = (float)SpeedRate_;
            }


            float rate = -jz * 0.01f * (float)SpeedRate_;
            velocity_ += rate;
            if (velocity_ < 0)
            {
                velocity_ = 0;
            }
            if (velocity_ > SpeedRate_)
            {
                velocity_ = (float)SpeedRate_;
            }
            cur.Move += new DxMath.Vector3(fv_.X * velocity_, fv_.Y * velocity_, fv_.Z * velocity_);

            //ボタン
            if (bs_[9 - 1])
            {
                cur.Rotation = DxMath.Quaternion.RotationAxis(DxMath.Vector3.UnitY, 0);
            }
            if (bs_[10 - 1])
            {
                cur.Move = DxMath.Vector3.Zero;
            }

        }

        /** がんばらない通常移動 */
        private void typeB()
        {
            float rate;
            float pitch = 0;
            float roll = 0;

            if (curPov_ >= 0 && prePov_ < 0)
            {
                if (bs_[5 - 1])
                {
                    switch (curPov_)
                    {
                        case 0:
                            pitch = -1;
                            break;
                        case 18000:
                            pitch = 1;
                            break;

                        case 9000:
                            roll = -1;
                            break;
                        case 27000:
                            roll = 1;
                            break;
                    }

                }
                else
                {

                    // 上下で最大速度の変更
                    switch (curPov_)
                    {
                        case 0:
                            maxSpeedParam_ += 1;
                            break;
                        case 18000:
                            maxSpeedParam_ -= 1;
                            if (maxSpeedParam_ < -1)
                            {
                                maxSpeedParam_ = -1;
                            }
                            break;
                    }

                }

                if (roll != 0)
                {
                    double ang = 2.0 * Math.PI / 8.0 * (double)roll;

                    DxMath.Vector3 n = fv_.Axis;
                    n.Normalize();

                    DxMath.Quaternion rot = DxMath.Quaternion.RotationAxis(n, (float)ang);

                    cur.Rotation = rot * cur.Rotation;
                }
                if (pitch != 0)
                {
                    double ang = 2.0 * Math.PI / 8.0 * (double)pitch;

                    DxMath.Vector3 n = rv_.Axis;
                    n.Normalize();

                    DxMath.Quaternion rot = DxMath.Quaternion.RotationAxis(n, (float)ang);

                    cur.Rotation = rot * cur.Rotation;
                }

            }
            if (maxSpeedParam_ >= 0)
            {
                SpeedRate_ = Math.Pow(2, maxSpeedParam_);
            }
            else
            {
                SpeedRate_ = 0;
            }


            //スティック
            float jx = stick_.X * Math.Abs(stick_.X);
            float jy = -stick_.Y * Math.Abs(stick_.Y);
            float jz = -stick_.Z * Math.Abs(stick_.Z);
            float jrz = stick_.W * Math.Abs(stick_.W);

// X軸Y軸
            if (bs_[5 - 1])
            { // 平行移動
                rate = jx * (float)SpeedRate_;
                cur.Move += new DxMath.Vector3(rv_.X * rate, rv_.Y * rate, rv_.Z * rate);

                rate = jy * (float)SpeedRate_;
                cur.Move += new DxMath.Vector3(fv_.X * rate, fv_.Y * rate, fv_.Z * rate);
            }
            else
            {
                double ang = jx * RotRate;

                DxMath.Vector3 n = tv_.Axis;
                n.Normalize();

                DxMath.Quaternion jrot = DxMath.Quaternion.RotationAxis(n, (float)ang);
                cur.Rotation = jrot * cur.Rotation;

                rate = jy * (float)SpeedRate_;
                cur.Move += new DxMath.Vector3(fv_.X * rate, fv_.Y * rate, fv_.Z * rate);
            }
            // 右スティック
            rate = jz * (float)SpeedRate_;
            cur.Move += new DxMath.Vector3(tv_.X * rate, tv_.Y * rate, tv_.Z * rate);


            //ボタン
            if (bs_[9 - 1])
            {
                cur.Rotation = DxMath.Quaternion.RotationAxis(DxMath.Vector3.UnitY, 0);
            }
            if (bs_[10 - 1])
            {
                cur.Move = DxMath.Vector3.Zero;
            }

        }

        public void Update(float Frame,
            float ElapsedTime)
        {

// 姿勢を表現するベクトルを得る
            DxMath.Quaternion rv = new DxMath.Quaternion(DxMath.Vector3.UnitX, 0);
            DxMath.Quaternion tv = new DxMath.Quaternion(DxMath.Vector3.UnitY, 0);
            DxMath.Quaternion fv = new DxMath.Quaternion(DxMath.Vector3.UnitZ, 0);

            if (this.myUserControl.IsTurn)
            {
                rv = new DxMath.Quaternion(-DxMath.Vector3.UnitX, 0);
                fv = new DxMath.Quaternion(-DxMath.Vector3.UnitZ, 0);
            }


            DxMath.Quaternion rot = cur.Rotation;
            DxMath.Quaternion rotc = rot;
            rotc.Conjugate();

            rv_ = rot * rv * rotc;
            tv_ = rot * tv * rotc;
            fv_ = rot * fv * rotc;
            // 共役が後 で期待するベクトルが取得できた

                if (this.di.IsAvailableJoyState() && myUserControl.IsUsePad)
                {
// ボタン12個
                    byte[] buts = this.di.JoyState.GetButtons();
                    bs_ = new bool[12];
                    for (int i = 1; i <= 12; ++i)
                    {
                        if (buts.Length >= 1)
                        {
                            if ((buts[i - 1] & 0x80) != 0)
                            {
                                bs_[i - 1] = true;
                            }
                        }
                    }

// POV1つ
                    int[] povs = this.di.JoyState.GetPointOfView();
                    curPov_ = -1;
                    if (povs.Length >= 1)
                    {
                        curPov_ = povs[0];
                    }

// 2スティック(4軸)
                    float jx = ((float)this.di.JoyState.X) - PadCenter; // ねじる
                    float jy = ((float)this.di.JoyState.Y) - PadCenter; // 仰角
                    float jz = ((float)this.di.JoyState.Z) - PadCenter; // アクセル
                    float jrz = ((float)this.di.JoyState.Rz) - PadCenter;
                    if (Math.Abs(jx) <= decimal.ToSingle(myUserControl.NoRotThr))
                    {
                        jx = 0;
                    }
                    if (Math.Abs(jy) <= decimal.ToSingle(myUserControl.NoRotThr))
                    {
                        jy = 0;
                    }
                    if (Math.Abs(jz) <= decimal.ToSingle(myUserControl.NoSlideThr))
                    {
                        jz = 0;
                    }
                    if (Math.Abs(jrz) <= decimal.ToSingle(myUserControl.NoSlideThr))
                    {
                        jrz = 0;
                    }

                    jx /= PadCenter;
                    jy /= PadCenter;
                    jz /= PadCenter;
                    jrz /= PadCenter; // [-1,+-0,+1]

                    stick_ = new DxMath.Vector4(jx, jy, jz, jrz);


                    switch (this.myUserControl.ControlType)
                    {
                        case 0:
                            typeA();
                            break;
                        case 1:
                            typeB();
                            break;
                    }

                    prePov_ = povs[0];
                }
                else
                {
                    prePov_ = -1;
                }

            myUserControl.MaxSpeed = "" + SpeedRate_;


            // モデルの探索
            Model targetModel = null;
            Bone center = null;

            foreach (Model m in Scene.Models)
            {
                if (m.Name == myUserControl.TargetModelName)
                {
                    targetModel = m;
                    break;
                }
            }

            if (targetModel != null)
            {
                // ボーン探索
                foreach (Bone b in targetModel.Bones)
                {
                    if (b.Name == myUserControl.TargetBoneName)
                    {
                        center = b;
                        break;
                    }
                }
            }

            myUserControl.ModelFound = (targetModel != null) ? "有" : "無";
            myUserControl.BoneFound = (center != null) ? "有" : "無";

            if (targetModel == null || center == null)
            {
                return;
            }


// 位置と姿勢の反映
            foreach (MotionLayer ml in center.Layers)
            {
                MotionData md = ml.CurrentLocalMotion;
                md.Move = cur.Move;
                md.Rotation = cur.Rotation;
                ml.CurrentLocalMotion = md;
            }

        }

        public void Disabled()
        {
            di = null;

            myUserControl.ModelFound = "-";
            myUserControl.BoneFound = "-";
            myUserControl.MaxSpeed = "-";
            myUserControl.PadName = "-";
        }

        public void Dispose()
        {
        }


        // セーブとロード //
        private void parseParam(Stream stream)
        {
            using (StreamReader r = new StreamReader(stream))
            {
                string ln;
                char[] sep = new char[1];
                sep[0] = ':';
                while ((ln = r.ReadLine()) != null)
                {
                    string[] ss = ln.Split(sep, 2);
                    if (ss.Length >= 2)
                    {
                        loadSaveParam[ss[0]] = ss[1];
                    }
                }
            }

            myUserControl.ControlType = 1;

            myUserControl.TargetModelName = loadSaveParam["TargetModelName"].ToString();
            myUserControl.TargetBoneName = loadSaveParam["TargetBoneName"].ToString();
            myUserControl.NoRotThr = decimal.Parse(loadSaveParam["NoRotThr"].ToString());           
            myUserControl.NoSlideThr = decimal.Parse(loadSaveParam["NoSlideThr"].ToString());
            myUserControl.IsUsePad = bool.Parse(loadSaveParam["IsUsePad"].ToString());
            myUserControl.IsTurn = bool.Parse(loadSaveParam["IsTurn"].ToString());
            myUserControl.ControlType = int.Parse(loadSaveParam["ControlType"].ToString());
        }
        private string makeParam()
        {
            StringBuilder sb = new StringBuilder();
            Hashtable ht = new Hashtable();

            
            ht["TargetModelName"] = myUserControl.TargetModelName;
            ht["TargetBoneName"] = myUserControl.TargetBoneName;
            ht["NoRotThr"] = myUserControl.NoRotThr;
            ht["NoSlideThr"] = myUserControl.NoSlideThr;
            ht["IsUsePad"] = myUserControl.IsUsePad;
            ht["IsTurn"] = myUserControl.IsTurn;
            ht["ControlType"] = myUserControl.ControlType;

            foreach (DictionaryEntry de in ht)
            {
                sb.AppendLine(string.Format("{0}:{1}",de.Key,de.Value));
            }
            return sb.ToString();
        }

        public Stream OnSaveProject()
        {
            Stream ret = new MemoryStream();
            string param = makeParam();
            byte[] buf = Encoding.UTF8.GetBytes(param);
            ret.Write(buf, 0, buf.Length);
            return ret;
        }

        public void OnLoadProject(Stream stream)
        {
            parseParam(stream);
        }

    }

    //DirectInputコントロールクラス
    class clsDirectInput
    {
        Microsoft.DirectX.DirectInput.Device device;
        Microsoft.DirectX.DirectInput.KeyboardState keyState;

        Microsoft.DirectX.DirectInput.Device joyDevice;
        Microsoft.DirectX.DirectInput.JoystickState joyState;

        public KeyboardState eyboardState
        {
            get { return keyState; }
        }

        public JoystickState JoyState
        {
            get { return joyState; }
        }
        public string PadName = "-";

        //DirectInput初期化
        public clsDirectInput()
        {
            device = new Microsoft.DirectX.DirectInput.Device(SystemGuid.Keyboard);
            device.Acquire();

            PadName = EnumJoyDevice();
        }

        //キーボードステータスの取得
        public void GetCurrentKeyboardState()
        {
            keyState = device.GetCurrentKeyboardState();
        }

        public string EnumJoyDevice()
        {
            string name = "-";
            DeviceList dl = Microsoft.DirectX.DirectInput.Manager.GetDevices(DeviceClass.GameControl, EnumDevicesFlags.AttachedOnly);
            foreach (DeviceInstance i in dl)
            {
                joyDevice = new Device(i.InstanceGuid); // 最初のデバイスを採用
                joyDevice.Acquire();
                name = i.ProductName;
                break;
            }
            return name;
        }

        public bool IsAvailableJoyState()
        {
            if (joyDevice == null)
            {
                return false;
            }

            joyState = joyDevice.CurrentJoystickState;
            return true;
        }

    }

}
